## mingw-w64-lua-cjson-2.1.0.16-1.src.tar.zst

=== CMakeLists.txt ===
# If Lua is installed in a non-standard location, please set the LUA_DIR
# environment variable to point to prefix for the install. Eg:
#       Unix: export LUA_DIR=/home/user/pkg
#       Windows: set LUA_DIR=c:\lua51

project(lua-cjson C)
cmake_minimum_required(VERSION 2.8.12)

option(USE_INTERNAL_FPCONV "Use internal strtod() / g_fmt() code for performance")
option(MULTIPLE_THREADS "Support multi-threaded apps with internal fpconv - recommended" ON)

if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release CACHE STRING
        "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
        FORCE)
endif()

find_package(Lua REQUIRED)
include_directories(${LUA_INCLUDE_DIR})

if(NOT USE_INTERNAL_FPCONV)
    # Use libc number conversion routines (strtod(), sprintf())
    set(FPCONV_SOURCES fpconv.c)
else()
    # Use internal number conversion routines
    add_definitions(-DUSE_INTERNAL_FPCONV)
    set(FPCONV_SOURCES g_fmt.c dtoa.c)

    include(TestBigEndian)
    TEST_BIG_ENDIAN(IEEE_BIG_ENDIAN)
    if(IEEE_BIG_ENDIAN)
        add_definitions(-DIEEE_BIG_ENDIAN)
    endif()

    if(MULTIPLE_THREADS)
        set(CMAKE_THREAD_PREFER_PTHREAD TRUE)
        find_package(Threads REQUIRED)
        if(NOT CMAKE_USE_PTHREADS_INIT)
            message(FATAL_ERROR
                    "Pthreads not found - required by MULTIPLE_THREADS option")
        endif()
        add_definitions(-DMULTIPLE_THREADS)
    endif()
endif()

# Handle platforms missing isinf() macro (Eg, some Solaris systems).
include(CheckSymbolExists)
CHECK_SYMBOL_EXISTS(isinf math.h HAVE_ISINF)
if(NOT HAVE_ISINF)
    add_definitions(-DUSE_INTERNAL_ISINF)
endif()

set(_MODULE_LINK "${CMAKE_THREAD_LIBS_INIT}")
get_filename_component(_lua_lib_dir ${LUA_LIBRARY} PATH)

if(APPLE)
    set(CMAKE_SHARED_MODULE_CREATE_C_FLAGS
        "${CMAKE_SHARED_MODULE_CREATE_C_FLAGS} -undefined dynamic_lookup")
endif()

if(WIN32)
    # Win32 modules need to be linked to the Lua library.
    set(_MODULE_LINK ${LUA_LIBRARY} ${_MODULE_LINK})
    set(_lua_module_dir "${_lua_lib_dir}")
    # Windows sprintf()/strtod() handle NaN/inf differently. Not supported.
    add_definitions(-DDISABLE_INVALID_NUMBERS)
else()
    set(_lua_module_dir "${_lua_lib_dir}/lua/5.1")
endif()

if(MSVC)
    add_definitions(-D_CRT_SECURE_NO_WARNINGS)
    add_definitions(-Dinline=__inline)
    add_definitions(-Dsnprintf=_snprintf)
    add_definitions(-Dstrncasecmp=_strnicmp)
endif()

add_library(cjson MODULE lua_cjson.c strbuf.c ${FPCONV_SOURCES})
set_target_properties(cjson PROPERTIES PREFIX "")
target_link_libraries(cjson ${_MODULE_LINK})
install(TARGETS cjson DESTINATION "${_lua_module_dir}")

# vi:ai et sw=4 ts=4:

=== Makefile ===
##### Available defines for CJSON_CFLAGS #####
##
## USE_INTERNAL_ISINF:      Workaround for Solaris platforms missing isinf().
## DISABLE_INVALID_NUMBERS: Permanently disable invalid JSON numbers:
##                          NaN, Infinity, hex.
##
## Optional built-in number conversion uses the following defines:
## USE_INTERNAL_FPCONV:     Use builtin strtod/dtoa for numeric conversions.
## IEEE_BIG_ENDIAN:         Required on big endian architectures.
## MULTIPLE_THREADS:        Must be set when Lua CJSON may be used in a
##                          multi-threaded application. Requries _pthreads_.

##### Build defaults #####
LUA_VERSION =       5.1
TARGET =            cjson.so
PREFIX =            /usr/local
#CFLAGS =            -g -Wall -pedantic -fno-inline
CFLAGS =            -O3 -Wall -pedantic -DNDEBUG -g
CJSON_CFLAGS =      -fpic
CJSON_LDFLAGS =     -shared
LUA_INCLUDE_DIR ?=   $(PREFIX)/include
LUA_CMODULE_DIR ?=   $(PREFIX)/lib/lua/$(LUA_VERSION)
LUA_MODULE_DIR ?=    $(PREFIX)/share/lua/$(LUA_VERSION)
LUA_BIN_DIR ?=       $(PREFIX)/bin

##### Platform overrides #####
##
## Tweak one of the platform sections below to suit your situation.
##
## See http://lua-users.org/wiki/BuildingModules for further platform
## specific details.

## Linux

## FreeBSD
#LUA_INCLUDE_DIR =   $(PREFIX)/include/lua51

## MacOSX (Macports)
#PREFIX =            /opt/local
#CJSON_LDFLAGS =     -bundle -undefined dynamic_lookup

## Solaris
#PREFIX =            /home/user/opt
#CC =                gcc
#CJSON_CFLAGS =      -fpic -DUSE_INTERNAL_ISINF

## Windows (MinGW)
#TARGET =            cjson.dll
#PREFIX =            /home/user/opt
#CJSON_CFLAGS =      -DDISABLE_INVALID_NUMBERS
#CJSON_LDFLAGS =     -shared -L$(PREFIX)/lib -llua51
#LUA_BIN_SUFFIX =    .lua

##### Number conversion configuration #####

## Use Libc support for number conversion (default)
FPCONV_OBJS =       fpconv.o

## Use built in number conversion
#FPCONV_OBJS =       g_fmt.o dtoa.o
#CJSON_CFLAGS +=     -DUSE_INTERNAL_FPCONV

## Compile built in number conversion for big endian architectures
#CJSON_CFLAGS +=     -DIEEE_BIG_ENDIAN

## Compile built in number conversion to support multi-threaded
## applications (recommended)
#CJSON_CFLAGS +=     -pthread -DMULTIPLE_THREADS
#CJSON_LDFLAGS +=    -pthread

##### End customisable sections #####

TEST_FILES =        README bench.lua genutf8.pl test.lua octets-escaped.dat \
                    example1.json example2.json example3.json example4.json \
                    example5.json numbers.json rfc-example1.json \
                    rfc-example2.json types.json
DATAPERM =          644
EXECPERM =          755

ASCIIDOC =          asciidoc

BUILD_CFLAGS =      -I$(LUA_INCLUDE_DIR) $(CJSON_CFLAGS)
OBJS =              lua_cjson.o strbuf.o $(FPCONV_OBJS)

.PHONY: all clean install install-extra doc

.SUFFIXES: .html .adoc

.c.o:
	$(CC) -c $(CFLAGS) $(CPPFLAGS) $(BUILD_CFLAGS) -o $@ $<

.adoc.html:
	$(ASCIIDOC) -n -a toc $<

all: $(TARGET)

doc: manual.html performance.html

$(TARGET): $(OBJS)
	$(CC) -o $@ $(LDFLAGS) $(CJSON_LDFLAGS) $(OBJS)

install: $(TARGET)
	mkdir -p $(DESTDIR)$(LUA_CMODULE_DIR)
	rm -f $(DESTDIR)$(LUA_CMODULE_DIR)/$(TARGET)
	cp $(TARGET) $(DESTDIR)$(LUA_CMODULE_DIR)
	chmod $(EXECPERM) $(DESTDIR)$(LUA_CMODULE_DIR)/$(TARGET)

install-extra:
	mkdir -p $(DESTDIR)$(LUA_MODULE_DIR)/cjson/tests \
		$(DESTDIR)$(LUA_BIN_DIR)
	cp lua/cjson/util.lua $(DESTDIR)$(LUA_MODULE_DIR)/cjson
	chmod $(DATAPERM) $(DESTDIR)$(LUA_MODULE_DIR)/cjson/util.lua
	cp lua/lua2json.lua $(DESTDIR)$(LUA_BIN_DIR)/lua2json$(LUA_BIN_SUFFIX)
	chmod $(EXECPERM) $(DESTDIR)$(LUA_BIN_DIR)/lua2json$(LUA_BIN_SUFFIX)
	cp lua/json2lua.lua $(DESTDIR)$(LUA_BIN_DIR)/json2lua$(LUA_BIN_SUFFIX)
	chmod $(EXECPERM) $(DESTDIR)$(LUA_BIN_DIR)/json2lua$(LUA_BIN_SUFFIX)
	cd tests; cp $(TEST_FILES) $(DESTDIR)$(LUA_MODULE_DIR)/cjson/tests
	cd tests; chmod $(DATAPERM) $(TEST_FILES); chmod $(EXECPERM) *.lua *.pl

clean:
	rm -f *.o $(TARGET)

=== PKGBUILD ===
# Maintainer: luau-project <luau.project@gmail.com>

_pkgsuffix=cjson
_realname=lua-${_pkgsuffix}
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-lua-${_pkgsuffix}"
         "${MINGW_PACKAGE_PREFIX}-lua51-${_pkgsuffix}"
         "${MINGW_PACKAGE_PREFIX}-lua53-${_pkgsuffix}")
pkgver=2.1.0.16
pkgrel=1
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url='https://github.com/openresty/lua-cjson'
license=('spdx:MIT')
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-lua"
             "${MINGW_PACKAGE_PREFIX}-lua51"
             "${MINGW_PACKAGE_PREFIX}-lua53"
             "${MINGW_PACKAGE_PREFIX}-pkgconf")
source=("${url}/archive/${pkgver}/${_realname}-${pkgver}.tar.gz")
sha256sums=('4b7e96801ee9596216d52d09cc4d21657cfd575971b6bbe9e317a698ae376a8a')

prepare() {
  # current Lua
  _lua_ver=$(pkgconf --variable=V lua)
  _lua_ver_short=$(echo $_lua_ver | sed -En "s/\.//p")

  _options=("LUA_VERSION=${_lua_ver}"
            "PREFIX=${MINGW_PREFIX}"
            "TARGET=cjson.dll"
            "CJSON_CFLAGS=-DDISABLE_INVALID_NUMBERS"
            "CJSON_LDFLAGS=-shared ${MINGW_PREFIX}/bin/lua${_lua_ver_short}.dll"
            "LUA_BIN_SUFFIX=.lua")

  # Lua 5.1
  _lua_ver51=$(pkgconf --variable=V lua5.1)
  _lua_ver_short51=$(echo $_lua_ver51 | sed -En "s/\.//p")

  _options51=("LUA_VERSION=${_lua_ver51}"
             "PREFIX=${MINGW_PREFIX}"
             "TARGET=cjson.dll"
             "LUA_INCLUDE_DIR=${MINGW_PREFIX}/include/lua${_lua_ver51}"
             "CJSON_CFLAGS=-DDISABLE_INVALID_NUMBERS"
             "CJSON_LDFLAGS=-shared ${MINGW_PREFIX}/bin/lua${_lua_ver_short51}.dll"
             "LUA_BIN_SUFFIX=.lua")

  cp -r "${srcdir}/${_realname}-${pkgver}" "${srcdir}/${_realname}-${pkgver}-51"

  sed -e "s/json2lua\.lua/json2lua${_lua_ver_short51}.lua/" \
      -e "s/\#\!\/usr\/bin\/env lua/\#\!\/usr\/bin\/env lua${_lua_ver51}/" \
      -i "${srcdir}/${_realname}-${pkgver}-51"/lua/json2lua.lua

  sed -e "s/lua2json\.lua/lua2json${_lua_ver_short51}.lua/" \
      -e "s/\#\!\/usr\/bin\/env lua/\#\!\/usr\/bin\/env lua${_lua_ver51}/" \
      -i "${srcdir}/${_realname}-${pkgver}-51"/lua/lua2json.lua

  sed -e "s/json2lua\$(LUA_BIN_SUFFIX)/json2lua${_lua_ver_short51}\$(LUA_BIN_SUFFIX)/" \
      -e "s/lua2json\$(LUA_BIN_SUFFIX)/lua2json${_lua_ver_short51}\$(LUA_BIN_SUFFIX)/" \
      -i "${srcdir}/${_realname}-${pkgver}-51"/Makefile

  for entry in "${srcdir}/${_realname}-${pkgver}-51"/tests/*.lua;
  do
    sed -e "s/\#\!\/usr\/bin\/env lua/\#\!\/usr\/bin\/env lua${_lua_ver51}/" \
        -i $entry;
  done

  # Lua 5.3
  _lua_ver53=$(pkgconf --variable=V lua5.3)
  _lua_ver_short53=$(echo $_lua_ver53 | sed -En "s/\.//p")

  _options53=("LUA_VERSION=${_lua_ver53}"
             "PREFIX=${MINGW_PREFIX}"
             "TARGET=cjson.dll"
             "LUA_INCLUDE_DIR=${MINGW_PREFIX}/include/lua${_lua_ver53}"
             "CJSON_CFLAGS=-DDISABLE_INVALID_NUMBERS"
             "CJSON_LDFLAGS=-shared ${MINGW_PREFIX}/bin/lua${_lua_ver_short53}.dll"
             "LUA_BIN_SUFFIX=.lua")

  cp -r "${srcdir}/${_realname}-${pkgver}" "${srcdir}/${_realname}-${pkgver}-53"

  sed -e "s/json2lua\.lua/json2lua${_lua_ver_short53}.lua/" \
      -e "s/\#\!\/usr\/bin\/env lua/\#\!\/usr\/bin\/env lua${_lua_ver53}/" \
      -i "${srcdir}/${_realname}-${pkgver}-53"/lua/json2lua.lua

  sed -e "s/lua2json\.lua/lua2json${_lua_ver_short53}.lua/" \
      -e "s/\#\!\/usr\/bin\/env lua/\#\!\/usr\/bin\/env lua${_lua_ver53}/" \
      -i "${srcdir}/${_realname}-${pkgver}-53"/lua/lua2json.lua

  sed -e "s/json2lua\$(LUA_BIN_SUFFIX)/json2lua${_lua_ver_short53}\$(LUA_BIN_SUFFIX)/" \
      -e "s/lua2json\$(LUA_BIN_SUFFIX)/lua2json${_lua_ver_short53}\$(LUA_BIN_SUFFIX)/" \
      -i "${srcdir}/${_realname}-${pkgver}-53"/Makefile

  for entry in "${srcdir}/${_realname}-${pkgver}-53"/tests/*.lua;
  do
    sed -e "s/\#\!\/usr\/bin\/env lua/\#\!\/usr\/bin\/env lua${_lua_ver53}/" \
        -i $entry;
  done
}

build() {
  # current Lua
  cd "${srcdir}/${_realname}-${pkgver}"

  make \
    "${_options[@]}" \
    all

  # Lua 5.1
  cd "${srcdir}/${_realname}-${pkgver}-51"

  make \
    "${_options51[@]}" \
    all
  
  # Lua 5.3
  cd "${srcdir}/${_realname}-${pkgver}-53"

  make \
    "${_options53[@]}" \
    all
}

package_lua-cjson() {
  depends=("${MINGW_PACKAGE_PREFIX}-lua")
  pkgdesc="Lua CJSON is a fast JSON encoding/parsing module for Lua (mingw-w64)"

  cd "${srcdir}/${_realname}-${pkgver}"

  make \
    DESTDIR="${pkgdir}" \
    "${_options[@]}" \
    install install-extra
}

package_lua51-cjson() {
  depends=("${MINGW_PACKAGE_PREFIX}-lua51")
  pkgdesc="Lua CJSON is a fast JSON encoding/parsing module for Lua ${_lua_ver51} (mingw-w64)"

  cd "${srcdir}/${_realname}-${pkgver}-51"

  make \
    DESTDIR="${pkgdir}" \
    "${_options51[@]}" \
    install install-extra
}

package_lua53-cjson() {
  depends=("${MINGW_PACKAGE_PREFIX}-lua53")
  pkgdesc="Lua CJSON is a fast JSON encoding/parsing module for Lua ${_lua_ver53} (mingw-w64)"

  cd "${srcdir}/${_realname}-${pkgver}-53"

  make \
    DESTDIR="${pkgdir}" \
    "${_options53[@]}" \
    install install-extra
}

# generate wrappers
for _name in "${pkgname[@]}"; do
  _short="package_${_name#${MINGW_PACKAGE_PREFIX}-}"
  _func="$(declare -f "${_short}")"
  eval "${_func/#${_short}/package_${_name}}"
done
